#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cctype>

using namespace std;
int usage();
int main(int argc, char *argv[])
{
  if (argc != 4)
    return usage();
  FILE *bac_genome, *fastq;
  char read[1000], exclude[1001], filename[101], I[1000];
  unsigned int spot=1, length=atoi(argv[3]);
  int written=0;

  bac_genome=fopen(argv[1], "r");
  strcpy(filename, argv[2]);
  strcat(filename, ".fastq");
  fastq=fopen64(filename, "w");
  fgets(exclude, 1000, bac_genome);
  read[length]='\0';
  for (int a=0; a<length; a++)
    I[a]='I';
  I[length]='\0';
  for (int a=0; a<length; a++)
    {
      read[a]=fgetc(bac_genome);
      while (read[a]=='\n')
	read[a]=fgetc(bac_genome);
      read[a]=toupper(read[a]);
      if ( read[a]==EOF)
	{
	  fprintf(stdout, "0 reads written\n");
	  fclose(fastq);
	  return 0;
	}
       if ( read[a] !='A' && read[a] != 'C' && read[a] != 'G' && read[a] != 'T')
	 {
	   spot+=a+1;
	   a=-1;
	 }
    }
  fprintf(fastq, "@%u\n%s\n+\n%s\n",spot,read,I);
  written=1;
  while (!feof(bac_genome))
    {
      for (int a=0; a<(length-1); a++)
	read[a]=read[a+1];
      read[length-1]=toupper(fgetc(bac_genome));
      while (read[length-1]=='\n')
	read[length-1]=toupper(fgetc(bac_genome));
      if ( read[length-1]==EOF)
	{
	  fclose(fastq);
	  fprintf(stdout, "%d reads written\n", written);
	  return 0;
	}
      spot++;
      if  (read[length-1] !='A' && read[length-1] != 'C' && read[length-1] != 'G' && read[length-1] != 'T')
	{
	  spot+=length;
	  for (int a=0; a<length; a++)
	    {
	      read[a]=fgetc(bac_genome);
	      while (read[a]=='\n')
		read[a]=fgetc(bac_genome);
	      read[a]=toupper(read[a]);
	      if ( read[a]==EOF)
		{
		  fclose(fastq);
		  fprintf(stdout, "%d reads written\n", written);
		  return 0;
		}
	      if ( read[a] !='A' && read[a] != 'C' && read[a] != 'G' && read[a] != 'T')
		{
		  spot+=a+1;
		    a=-1;
		}
	    }
	}
      fprintf(fastq, "@%u\n%s\n+\n%s\n",spot,read,I);
      written++;
      if ((written%5000000)==0)
	fprintf(stdout, "%d reads written\n", written);
    }
  fprintf(stdout, "%d reads written\n", written);
  return 0;
}

int usage()
{
  fprintf(stdout, "Usage\tmakereads <in.fa> <out> <read length>\n");
return 0;
}
